part of viltage;

class Input {
  static HashMap<int, int> _keys = new HashMap<int, int>();
  static HashMap<int, int> _lastKeys = new HashMap<int, int>();
  
  static init() {
    window.onKeyDown.listen((KeyboardEvent e) {
      if (!_keys.containsKey(e.keyCode)) {
        _lastKeys[e.keyCode] = e.timeStamp;
        _keys[e.keyCode] = e.timeStamp;
      } else {
        _lastKeys.remove(e.keyCode);
      }
    });

    window.onKeyUp.listen((KeyboardEvent e) {
      _keys.remove(e.keyCode);
      _lastKeys.remove(e.keyCode);
    });
  }

  static bool isHeld(int keyCode) => _keys.containsKey(keyCode);
  
  static bool isPressed(int keyCode) => _lastKeys.containsKey(keyCode);
}